<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\shops;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\shops\ShopOrders;
use app\common\lists\ListsSearchInterface;
use think\db\Query;


/**
 * ShopOrders列表
 * Class ShopOrdersLists
 * @package app\adminapi\listsshops
 */
class ShopOrdersLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/08/04 13:49
     */
    public function setSearch(): array
    {
        return [
            '=' => ['shop_order_type', 'worker_id', 'real_name', 'mobile', 'pay_status', 'pay_sn', 'paw_way', 'order_terminal', 'transaction_id', 'refund_status'],
            '%like%' => ['sn', 'refund_transaction_id'],

        ];
    }

    public function querySearch():array
    {
        $where = [];
        if(isset($this->params['pay_time']) && !empty($this->params['pay_time'])){
            $time = [strtotime($this->params['pay_time'][0]), strtotime($this->params['pay_time'][1])];
            $where[] = ['pay_time', 'between', $time];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/08/04 13:49
     */
    public function lists(): array
    {
        return ShopOrders::with([
            'worker'=>function(Query $query) {
                $query->field("id,worker_number,real_name");
            },])
            ->where($this->searchWhere)
            ->where($this->querySearch())
            ->field(['id', 'shop_order_type', 'worker_id', 'sn', 'real_name', 'mobile', 'address', 'pay_time', 'pay_status', 'pay_sn', 'paw_way', 'order_terminal', 'amount_total', 'order_amount', 'transaction_id', 'refund_status', 'refund_transaction_id'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/08/04 13:49
     */
    public function count(): int
    {
        return ShopOrders::where($this->searchWhere)->where($this->querySearch())->count();
    }

}